﻿Partial Public Class MainPage
    Inherits UserControl

    Dim dataList As New List(Of MyDataClass)

    Public Sub New()
        InitializeComponent()

        Dim dt As DateTime = DateTime.Now

        dataList.Add(New MyDataClass(1, "John", True, dt.AddDays(10)))
        dataList.Add(New MyDataClass(2, "James", False, dt.AddDays(-10)))
        dataList.Add(New MyDataClass(3, "Dave", False, dt.AddDays(30)))
        dataList.Add(New MyDataClass(4, "Peter", True, dt.AddDays(-50)))
        dataList.Add(New MyDataClass(5, "Sam", False, dt.AddDays(-90)))
        dataList.Add(New MyDataClass(6, "Tim", True, dt.AddDays(100)))

        C1DataGrid1.ItemsSource = dataList

    End Sub

    Private Sub C1DataGrid1_LoadedCellPresenter(sender As Object, e As C1.Silverlight.DataGrid.DataGridCellEventArgs) Handles C1DataGrid1.LoadedCellPresenter
        If e.Cell.Column.GetType() Is GetType(C1.Silverlight.DataGrid.DataGridCheckBoxColumn) Then
            Dim newCheckBox As New CheckBox()

            Dim bnd As New System.Windows.Data.Binding()
            bnd.Source = e.Cell
            bnd.Path = New PropertyPath("Value")
            bnd.Mode = System.Windows.Data.BindingMode.TwoWay
            newCheckBox.SetBinding(CheckBox.IsCheckedProperty, bnd)
            e.Cell.Presenter.Content = newCheckBox
            e.Cell.Presenter.HorizontalContentAlignment = System.Windows.HorizontalAlignment.Center
            e.Cell.Presenter.VerticalContentAlignment = System.Windows.VerticalAlignment.Center
        End If

    End Sub
End Class

Public Class MyDataClass

    Public Sub New()
    End Sub

    Public Sub New(_id As Integer, _name As String, _status As Boolean, _dob As DateTime)
        ID = _id
        Name = _name
        Status = _status
        DateOfBirth = _dob
    End Sub

    Public Property ID() As Integer
        Get
            Return m_ID
        End Get
        Set(value As Integer)
            m_ID = value
        End Set
    End Property
    Private m_ID As Integer

    Public Property Name() As String
        Get
            Return m_Name
        End Get
        Set(value As String)
            m_Name = value
        End Set
    End Property
    Private m_Name As String

    Public Property Status() As Boolean
        Get
            Return m_Status
        End Get
        Set(value As Boolean)
            m_Status = value
        End Set
    End Property
    Private m_Status As Boolean

    Public Property DateOfBirth() As DateTime
        Get
            Return m_DateOfBirth
        End Get
        Set(value As DateTime)
            m_DateOfBirth = value
        End Set
    End Property
    Private m_DateOfBirth As DateTime

End Class
